"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var useCalendar_exports = {};
__export(useCalendar_exports, {
  useCalendar: () => useCalendar
});
module.exports = __toCommonJS(useCalendar_exports);
var import_startOfDay = __toESM(require("date-fns/startOfDay"));
var import_react = require("react");
var import_utils = require("./utils");
function isOffsetControlled(propOffset) {
  return propOffset !== void 0;
}
function getOffset(prop, state) {
  return isOffsetControlled(prop) ? prop : state;
}
function getDateProps(onDateSelected, { onClick, dateObj }) {
  return {
    onClick: (0, import_utils.composeEventHandlers)(onClick, (event) => {
      onDateSelected(dateObj, event);
    }),
    disabled: !dateObj.selectable,
    "aria-pressed": dateObj.selected,
    role: "button"
  };
}
function getBackProps({ minDate, offsetMonth, handleOffsetChanged }, { onClick, offset = 1, calendars }) {
  const label = "G\xE5 tilbake ".concat(offset, " m\xE5ned").concat(offset === 1 ? "" : "er");
  return {
    onClick: (0, import_utils.composeEventHandlers)(onClick, () => {
      handleOffsetChanged(
        offsetMonth - (0, import_utils.subtractMonth)({ calendars, offset, minDate })
      );
    }),
    disabled: (0, import_utils.isBackDisabled)({ calendars, minDate }),
    "aria-label": label,
    title: label
  };
}
function getForwardProps({ maxDate, offsetMonth, handleOffsetChanged }, { onClick, offset = 1, calendars }) {
  const label = "G\xE5 frem ".concat(offset, " m\xE5ned").concat(offset === 1 ? "" : "er");
  return {
    onClick: (0, import_utils.composeEventHandlers)(onClick, () => {
      handleOffsetChanged(
        offsetMonth + (0, import_utils.addMonth)({ calendars, offset, maxDate })
      );
    }),
    disabled: (0, import_utils.isForwardDisabled)({ calendars, maxDate }),
    "aria-label": label,
    title: label
  };
}
function useCalendar({
  date = (0, import_startOfDay.default)(/* @__PURE__ */ new Date()),
  maxDate,
  minDate,
  monthsToDisplay = 1,
  firstDayOfWeek = 0,
  showOutsideDays = true,
  offset,
  onDateSelected,
  onOffsetChanged,
  selected
}) {
  const [stateOffset, setStateOffset] = (0, import_react.useState)(0);
  const offsetMonth = getOffset(offset, stateOffset);
  function handleOffsetChanged(newOffset) {
    if (!isOffsetControlled(offset)) {
      setStateOffset(newOffset);
    }
    onOffsetChanged(newOffset);
  }
  const calendars = (0, import_utils.getCalendars)({
    date,
    selected,
    monthsToDisplay,
    minDate,
    maxDate,
    offset: offsetMonth,
    firstDayOfWeek,
    showOutsideDays
  });
  return {
    calendars,
    getDateProps: getDateProps.bind(null, onDateSelected),
    getBackProps: getBackProps.bind(null, {
      minDate,
      offsetMonth,
      handleOffsetChanged
    }),
    getForwardProps: getForwardProps.bind(null, {
      maxDate,
      offsetMonth,
      handleOffsetChanged
    }),
    handleOffsetChanged
  };
}
//# sourceMappingURL=useCalendar.js.map
