"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var validation_exports = {};
__export(validation_exports, {
  isCorrectFormat: () => isCorrectFormat,
  isWithinLowerBound: () => isWithinLowerBound,
  isWithinUpperBound: () => isWithinUpperBound
});
module.exports = __toCommonJS(validation_exports);
var import_utils = require("./utils");
function isCorrectFormat(value) {
  if (!value) {
    return false;
  }
  const val = (0, import_utils.parseDateString)(value);
  return Boolean(val);
}
function isWithinLowerBound(value, minDate, options = { inclusive: false }) {
  const val = typeof value === "string" ? (0, import_utils.parseDateString)(value) : value;
  if (!val) {
    return false;
  }
  if (options.inclusive) {
    return val >= minDate;
  }
  return val > minDate;
}
function isWithinUpperBound(value, maxDate, options = { inclusive: false }) {
  const val = typeof value === "string" ? (0, import_utils.parseDateString)(value) : value;
  if (!val) {
    return false;
  }
  if (options.inclusive) {
    return val <= maxDate;
  }
  return val < maxDate;
}
//# sourceMappingURL=validation.js.map
