import { parseDateString } from "./utils";
function isCorrectFormat(value) {
  if (!value) {
    return false;
  }
  const val = parseDateString(value);
  return Boolean(val);
}
function isWithinLowerBound(value, minDate, options = { inclusive: false }) {
  const val = typeof value === "string" ? parseDateString(value) : value;
  if (!val) {
    return false;
  }
  if (options.inclusive) {
    return val >= minDate;
  }
  return val > minDate;
}
function isWithinUpperBound(value, maxDate, options = { inclusive: false }) {
  const val = typeof value === "string" ? parseDateString(value) : value;
  if (!val) {
    return false;
  }
  if (options.inclusive) {
    return val <= maxDate;
  }
  return val < maxDate;
}
export {
  isCorrectFormat,
  isWithinLowerBound,
  isWithinUpperBound
};
//# sourceMappingURL=validation.js.map
