import React from "react";
export declare const dayMonthYearRegex: RegExp;
/**
 * Format a Date object as a string in the format DatePicker expects.
 *
 * @param date the Date object to format
 * @return returns a date string with "dd.mm.yyyy"-format
 */
export declare function formatInput(date: Date): string;
/**
 * Convert a date string to a Date object
 *
 * @param dateString date as string with format dd.mm.yyyy
 * @return a Date object representing the given date
 */
export declare function parseDateString(dateString?: string): Date | undefined;
/**
 * Hjelpefunksjon for å se om en onBlur går utenfor DatePicker,
 * eller om den går til et interaktivt element inni DatePickeren.
 * @param {React.FocusEvent<HTMLButtonElement | HTMLInputElement>} e - Eventet fra onBlur og action.onBlur
 * @returns {boolean} true hvis e.relatedTarget er utenfor DatePicker
 */
export declare function isBlurTargetOutside(e: React.FocusEvent<HTMLButtonElement | HTMLInputElement>): boolean;
